/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include <GLFW/glfw3.h>

#include <ox/std/string.hpp>

#include <nostalgia/core/core.hpp>

#include "core.hpp"

namespace nostalgia::core {

ox::String getClipboardText(Context *ctx) noexcept {
	const auto id = ctx->windowerData<GlfwImplData>();
	return glfwGetClipboardString(id->window);
}

void setClipboardText(Context *ctx, const ox::String &text) noexcept {
	const auto id = ctx->windowerData<GlfwImplData>();
	glfwSetClipboardString(id->window, text.c_str());
}

}
