/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#pragma once

#include <ox/event/signal.hpp>

#include <nostalgia/core/context.hpp>

namespace nostalgia::studio {

enum class TaskState {
	Running,
	Done
};

class Task: public ox::SignalHandler {
	public:
		virtual ~Task() noexcept = default;
		virtual TaskState update(nostalgia::core::Context *ctx) noexcept = 0;
};

class TaskRunner {
	private:
		ox::Vector<ox::UniquePtr<studio::Task>> m_tasks;
	public:
		void update(core::Context *ctx) noexcept;
		void add(Task *task) noexcept;
};

}